## GtkListStore

GtkListStore

## Functions

GtkListStore * | gtk_list_store_new ()
GtkListStore * | gtk_list_store_newv ()
void | gtk_list_store_set_column_types ()
void | gtk_list_store_set ()
void | gtk_list_store_set_valist ()
void | gtk_list_store_set_value ()
void | gtk_list_store_set_valuesv ()
gboolean | gtk_list_store_remove ()
void | gtk_list_store_insert ()
void | gtk_list_store_insert_before ()
void | gtk_list_store_insert_after ()
void | gtk_list_store_insert_with_values ()
void | gtk_list_store_insert_with_valuesv ()
void | gtk_list_store_prepend ()
void | gtk_list_store_append ()
void | gtk_list_store_clear ()
gboolean | gtk_list_store_iter_is_valid ()
void | gtk_list_store_reorder ()
void | gtk_list_store_swap ()
void | gtk_list_store_move_before ()
void | gtk_list_store_move_after ()

## Types and Values

struct | GtkListStore

## Object Hierarchy

        GObject
        ╰── GtkListStore

## Implemented Interfaces

GtkListStore implements GtkTreeModel, GtkTreeDragSource, GtkTreeDragDest, GtkTreeSortable and GtkBuildable.

## Includes

    #include <gtk/gtk.h>

## Description

## Functions

### gtk_list_store_new ()

    GtkListStore *
    gtk_list_store_new (gint n_columns,
                        ...);

Creates a new list store as with `n_columns` columns each of the types passed in. Note that only types derived from standard GObject fundamental types are supported.

As an example, `gtk_tree_store_new (3, G_TYPE_INT, G_TYPE_STRING, GDK_TYPE_PIXBUF);` will create a new GtkListStore with three columns, of type int, string and GdkPixbuf respectively.

#### Parameters

n_columns | number of columns in the list store |
Varargs | all GType types for the columns, from first to last |

#### Returns

a new GtkListStore

### gtk_list_store_newv ()

    GtkListStore *
    gtk_list_store_newv (gint n_columns,
                         GType *types);

Non-vararg creation function. Used primarily by language bindings.

#### Parameters

n_columns | number of columns in the list store |
types | an array of GType types for the columns, from first to last. | [array length=n_columns]

#### Returns

a new GtkListStore.

[transfer none]

### gtk_list_store_set_column_types ()

    void
    gtk_list_store_set_column_types (GtkListStore *list_store,
                                     gint n_columns,
                                     GType *types);

This function is meant primarily for GObjects that inherit from GtkListStore, and should only be used when constructing a new GtkListStore. It will not function after a row has been added, or a method on the GtkTreeModel interface is called.

#### Parameters

list_store | A GtkListStore |
n_columns | Number of columns for the list store |
types | An array length n of GTypes. | [array length=n_columns]

### gtk_list_store_set ()

    void
    gtk_list_store_set (GtkListStore *list_store,
                        GtkTreeIter *iter,
                        ...);

Sets the value of one or more cells in the row referenced by `iter` . The variable argument list should contain integer column numbers, each column number followed by the value to be set. The list is terminated by a -1. For example, to set column 0 with type `G_TYPE_STRING` to "Foo", you would write `gtk_list_store_set (store, iter, 0, "Foo", -1)`.

The value will be referenced by the store if it is a `G_TYPE_OBJECT`, and it will be copied if it is a `G_TYPE_STRING` or `G_TYPE_BOXED`.

#### Parameters

list_store | a GtkListStore |
iter | row iterator |
Varargs | pairs of column number and value, terminated with -1 |

### gtk_list_store_set_valist ()

    void
    gtk_list_store_set_valist (GtkListStore *list_store,
                               GtkTreeIter *iter,
                               va_list var_args);

See `gtk_list_store_set()`; this version takes a va_list for use by language bindings.

#### Parameters

list_store | A GtkListStore |
iter | A valid GtkTreeIter for the row being modified |
var_args | va_list of column/value pairs |

### gtk_list_store_set_value ()

    void
    gtk_list_store_set_value (GtkListStore *list_store,
                              GtkTreeIter *iter,
                              gint column,
                              GValue *value);

Sets the data in the cell specified by `iter` and `column` . The type of `value` must be convertible to the type of the column.

#### Parameters

list_store | A GtkListStore |
iter | A valid GtkTreeIter for the row being modified |
column | column number to modify |
value | new value for the cell |

### gtk_list_store_set_valuesv ()

    void
    gtk_list_store_set_valuesv (GtkListStore *list_store,
                                GtkTreeIter *iter,
                                gint *columns,
                                GValue *values,
                                gint n_values);

A variant of `gtk_list_store_set_valist()` which takes the columns and values as two arrays, instead of varargs. This function is mainly intended for language-bindings and in case the number of columns to change is not known until run-time.

#### Parameters

list_store | A GtkListStore |
iter | A valid GtkTreeIter for the row being modified |
columns | an array of column numbers. | [array length=n_values]
values | an array of GValues. | [array length=n_values]
n_values | the length of the `columns` and `values` arrays |

Since: 2.12

### gtk_list_store_remove ()

    gboolean
    gtk_list_store_remove (GtkListStore *list_store,
                           GtkTreeIter *iter);

Removes the given row from the list store. After being removed, `iter` is set to be the next valid row, or invalidated if it pointed to the last row in `list_store` .

#### Parameters

list_store | A GtkListStore |
iter | A valid GtkTreeIter |

#### Returns

`TRUE` if `iter` is valid, `FALSE` if not.

### gtk_list_store_insert ()

    void
    gtk_list_store_insert (GtkListStore *list_store,
                           GtkTreeIter *iter,
                           gint position);

Creates a new row at `position` . `iter` will be changed to point to this new row. If `position` is larger than the number of rows on the list, then the new row will be appended to the list. The row will be empty after this function is called. To fill in values, you need to call `gtk_list_store_set()` or `gtk_list_store_set_value()`.

#### Parameters

list_store | A GtkListStore |
iter | An unset GtkTreeIter to set to the new row. | [out]
position | position to insert the new row |

### gtk_list_store_insert_before ()

    void
    gtk_list_store_insert_before (GtkListStore *list_store,
                                  GtkTreeIter *iter,
                                  GtkTreeIter *sibling);

Inserts a new row before `sibling` . If `sibling` is `NULL`, then the row will be appended to the end of the list. `iter` will be changed to point to this new row. The row will be empty after this function is called. To fill in values, you need to call `gtk_list_store_set()` or `gtk_list_store_set_value()`.

#### Parameters

list_store | A GtkListStore |
iter | An unset GtkTreeIter to set to the new row. | [out]
sibling | A valid GtkTreeIter, or `NULL`. | [allow-none]

### gtk_list_store_insert_after ()

    void
    gtk_list_store_insert_after (GtkListStore *list_store,
                                 GtkTreeIter *iter,
                                 GtkTreeIter *sibling);

Inserts a new row after `sibling` . If `sibling` is `NULL`, then the row will be prepended to the beginning of the list. `iter` will be changed to point to this new row. The row will be empty after this function is called. To fill in values, you need to call `gtk_list_store_set()` or `gtk_list_store_set_value()`.

#### Parameters

list_store | A GtkListStore |
iter | An unset GtkTreeIter to set to the new row. | [out]
sibling | A valid GtkTreeIter, or `NULL`. | [allow-none]

### gtk_list_store_insert_with_values ()

    void
    gtk_list_store_insert_with_values (GtkListStore *list_store,
                                       GtkTreeIter *iter,
                                       gint position,
                                       ...);

Creates a new row at `position` . `iter` will be changed to point to this new row. If `position` is larger than the number of rows on the list, then the new row will be appended to the list. The row will be filled with the values given to this function.

Calling `gtk_list_store_insert_with_values(list_store, iter, position...)` has the same effect as calling

    1
    2

    gtk_list_store_insert (list_store, iter, position);
    gtk_list_store_set (list_store, iter, ...);

with the difference that the former will only emit a row_inserted signal, while the latter will emit row_inserted, row_changed and, if the list store is sorted, rows_reordered. Since emitting the rows_reordered signal repeatedly can affect the performance of the program, `gtk_list_store_insert_with_values()` should generally be preferred when inserting rows in a sorted list store.

#### Parameters

list_store | A GtkListStore |
iter | An unset GtkTreeIter to set to the new row, or `NULL`. | [out][allow-none]
position | position to insert the new row |
Varargs | pairs of column number and value, terminated with -1 |

Since: 2.6

### gtk_list_store_insert_with_valuesv ()

    void
    gtk_list_store_insert_with_valuesv (GtkListStore *list_store,
                                        GtkTreeIter *iter,
                                        gint position,
                                        gint *columns,
                                        GValue *values,
                                        gint n_values);

A variant of `gtk_list_store_insert_with_values()` which takes the columns and values as two arrays, instead of varargs. This function is mainly intended for language-bindings.

#### Parameters

list_store | A GtkListStore |
iter | An unset GtkTreeIter to set to the new row, or `NULL`. | [out][allow-none]
position | position to insert the new row |
columns | an array of column numbers. | [array length=n_values]
values | an array of GValues. | [array length=n_values]
n_values | the length of the `columns` and `values` arrays |

Since: 2.6

### gtk_list_store_prepend ()

    void
    gtk_list_store_prepend (GtkListStore *list_store,
                            GtkTreeIter *iter);

Prepends a new row to `list_store` . `iter` will be changed to point to this new row. The row will be empty after this function is called. To fill in values, you need to call `gtk_list_store_set()` or `gtk_list_store_set_value()`.

#### Parameters

list_store | A GtkListStore |
iter | An unset GtkTreeIter to set to the prepend row. | [out]

### gtk_list_store_append ()

    void
    gtk_list_store_append (GtkListStore *list_store,
                           GtkTreeIter *iter);

Appends a new row to `list_store` . `iter` will be changed to point to this new row. The row will be empty after this function is called. To fill in values, you need to call `gtk_list_store_set()` or `gtk_list_store_set_value()`.

#### Parameters

list_store | A GtkListStore |
iter | An unset GtkTreeIter to set to the appended row. | [out]

### gtk_list_store_clear ()

    void
    gtk_list_store_clear (GtkListStore *list_store);

Removes all rows from the list store.

#### Parameters

list_store | a GtkListStore. |

### gtk_list_store_iter_is_valid ()

    gboolean
    gtk_list_store_iter_is_valid (GtkListStore *list_store,
                                  GtkTreeIter *iter);

This function is slow. Only use it for debugging and/or testing purposes.

Checks if the given iter is a valid iter for this GtkListStore.

#### Parameters

list_store | A GtkListStore. |
iter | A GtkTreeIter. |

#### Returns

`TRUE` if the iter is valid, `FALSE` if the iter is invalid.

Since: 2.2

### gtk_list_store_reorder ()

    void
    gtk_list_store_reorder (GtkListStore *store,
                            gint *new_order);

Reorders `store` to follow the order indicated by `new_order` . Note that this function only works with unsorted stores.

#### Parameters

store | A GtkListStore. |
new_order | an array of integers mapping the new position of each child to its old position before the re-ordering, i.e. `new_order` `[newpos] = oldpos`. | [array]

Since: 2.2

### gtk_list_store_swap ()

    void
    gtk_list_store_swap (GtkListStore *store,
                         GtkTreeIter *a,
                         GtkTreeIter *b);

Swaps `a` and `b` in `store` . Note that this function only works with unsorted stores.

#### Parameters

store | A GtkListStore. |
a | A GtkTreeIter. |
b | Another GtkTreeIter. |

Since: 2.2

### gtk_list_store_move_before ()

    void
    gtk_list_store_move_before (GtkListStore *store,
                                GtkTreeIter *iter,
                                GtkTreeIter *position);

Moves `iter` in `store` to the position before `position` . Note that this function only works with unsorted stores. If `position` is `NULL`, `iter` will be moved to the end of the list.

#### Parameters

store | A GtkListStore. |
iter | A GtkTreeIter. |
position | A GtkTreeIter, or `NULL`. | [allow-none]

Since: 2.2

### gtk_list_store_move_after ()

    void
    gtk_list_store_move_after (GtkListStore *store,
                               GtkTreeIter *iter,
                               GtkTreeIter *position);

Moves `iter` in `store` to the position after `position` . Note that this function only works with unsorted stores. If `position` is `NULL`, `iter` will be moved to the start of the list.

#### Parameters

store | A GtkListStore. |
iter | A GtkTreeIter. |
position | A GtkTreeIter or `NULL`. | [allow-none]

Since: 2.2

## Types and Values

### struct GtkListStore

    struct GtkListStore;